Index: modules/ParticleDensity.cc
===================================================================
--- modules/ParticleDensity.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/ParticleDensity.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,144 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** \class ParticleDensity
+ *
+ *  This module calculates the particle multiplicity density in eta-phi bins.
+ *  It then assigns the value to the candidates according to the candidate eta.
+ *
+ *  \author R. Preghenella - INFN, Bologna
+ *
+ */
+
+#include "modules/ParticleDensity.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include "ExRootAnalysis/ExRootClassifier.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootResult.h"
+
+#include "TFormula.h"
+#include "TLorentzVector.h"
+#include "TMath.h"
+#include "TObjArray.h"
+#include "TRandom3.h"
+#include "TString.h"
+#include "TH2F.h"
+
+#include <algorithm>
+#include <iostream>
+#include <sstream>
+#include <stdexcept>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+ParticleDensity::ParticleDensity() :
+  fItInputArray(0)
+{}
+
+//------------------------------------------------------------------------------
+
+ParticleDensity::~ParticleDensity()
+{}
+
+//------------------------------------------------------------------------------
+
+void ParticleDensity::Init()
+{
+
+  // import input array(s)
+
+  fInputArray = ImportArray(GetString("InputArray", "FastJetFinder/jets"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array(s)
+
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
+
+  // create multiplicity histogram
+
+  ExRootConfParam paramEta = GetParam("EtaBins");
+  const Long_t sizeEta = paramEta.GetSize();
+  Int_t nbinsEta = sizeEta - 1;
+  Float_t binsEta[sizeEta];
+  for (Int_t i = 0; i < sizeEta; ++i) {
+    binsEta[i] = paramEta[i].GetDouble();
+  }
+  
+  ExRootConfParam paramPhi = GetParam("PhiBins");
+  const Long_t sizePhi = paramPhi.GetSize();
+  Int_t nbinsPhi = sizePhi - 1;
+  Float_t binsPhi[sizePhi];
+  for (Int_t i = 0; i < sizePhi; ++i) {
+    binsPhi[i] = paramPhi[i].GetDouble();
+  }
+  
+  fHisto = new TH2F("hParticleDensity", ";#eta;#varphi;d^{2}N/d#etad#varphi", nbinsEta, binsEta, nbinsPhi, binsPhi);
+
+  fUseMomentumVector = GetBool("UseMomentumVector", false);
+}
+
+//------------------------------------------------------------------------------
+
+void ParticleDensity::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+  if (fHisto) delete fHisto;
+}
+
+//------------------------------------------------------------------------------
+
+void ParticleDensity::Process()
+{
+  Candidate *candidate;
+  fHisto->Reset();
+  
+  // loop over all input candidates to fill histogram
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next()))) {
+    if (fUseMomentumVector) fHisto->Fill(candidate->Momentum.Eta(), candidate->Momentum.Phi());
+    else                    fHisto->Fill(candidate->Position.Eta(), candidate->Position.Phi());
+  }
+
+  // normalise by bin width
+  fHisto->Scale(1., "width");
+  
+  // loop over all input candidates to assign multiplicity
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next()))) {
+    Int_t ieta, iphi;
+    if (fUseMomentumVector) {
+      ieta = fHisto->GetXaxis()->FindBin(candidate->Momentum.Eta());
+      iphi = fHisto->GetYaxis()->FindBin(candidate->Momentum.Phi());
+    } else {
+      ieta = fHisto->GetXaxis()->FindBin(candidate->Position.Eta());
+      iphi = fHisto->GetYaxis()->FindBin(candidate->Position.Phi());
+    }
+    candidate->ParticleDensity = fHisto->GetBinContent(ieta, iphi);
+    fOutputArray->Add(candidate);
+  }
+
+  
+}
+
+//------------------------------------------------------------------------------
Index: modules/ParticleDensity.h
===================================================================
--- modules/ParticleDensity.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/ParticleDensity.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,62 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef ParticleDensity_h
+#define ParticleDensity_h
+
+/** \class ParticleDensity
+ *
+ *  This module calculates the particle multiplicity density in eta-phi bins.
+ *  It then assigns the value to the candidates according to the candidate eta.
+ *
+ *  \author R. Preghenella - INFN, Bologna
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+#include <deque>
+
+class TObjArray;
+class TH2F;
+
+class ParticleDensity: public DelphesModule
+{
+public:
+  ParticleDensity();
+  ~ParticleDensity();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  Bool_t fUseMomentumVector; // !
+  TH2F *fHisto; //!
+  
+  ClassDef(ParticleDensity, 1)
+};
+
+#endif
Index: modules/ParticlePropagator.cc
===================================================================
--- modules/ParticlePropagator.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/ParticlePropagator.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -125,19 +125,21 @@
   TLorentzVector particlePosition, particleMomentum, beamSpotPosition;
   Double_t px, py, pz, pt, pt2, e, q;
-  Double_t x, y, z, t, r, phi;
-  Double_t x_c, y_c, r_c, phi_c, phi_0;
-  Double_t x_t, y_t, z_t, r_t;
-  Double_t t1, t2, t3, t4, t5, t6;
-  Double_t t_z, t_r, t_ra, t_rb;
-  Double_t tmp, discr, discr2;
-  Double_t delta, gammam, omega, asinrho;
-  Double_t rcu, rc2, xd, yd, zd;
-  Double_t l, d0, dz, p, ctgTheta, phip, etap, alpha;
+  Double_t x, y, z, t, r;
+  Double_t x_c, y_c, r_c, phi_0;
+  Double_t x_t, y_t, z_t, r_t, phi_t;
+  Double_t t_r, t_z;
+  Double_t tmp;
+  Double_t gammam, omega;
+  Double_t xd, yd, zd;
+  Double_t l, d0, dz, ctgTheta, alpha;
   Double_t bsx, bsy, bsz;
+  Double_t td, pio, phid, vz;
 
   const Double_t c_light = 2.99792458E8;
 
   if(!fBeamSpotInputArray || fBeamSpotInputArray->GetSize() == 0)
+  {
     beamSpotPosition.SetXYZT(0.0, 0.0, 0.0, 0.0);
+  }
   else
   {
@@ -160,4 +162,5 @@
     particlePosition = particle->Position;
     particleMomentum = particle->Momentum;
+
     x = particlePosition.X() * 1.0E-3;
     y = particlePosition.Y() * 1.0E-3;
@@ -206,25 +209,9 @@
       // solve pt2*t^2 + 2*(px*x + py*y)*t - (fRadius2 - x*x - y*y) = 0
       tmp = px * y - py * x;
-      discr2 = pt2 * fRadius2 - tmp * tmp;
-
-      if(discr2 < 0.0)
-      {
-        // no solutions
-        continue;
-      }
-
-      tmp = px * x + py * y;
-      discr = TMath::Sqrt(discr2);
-      t1 = (-tmp + discr) / pt2;
-      t2 = (-tmp - discr) / pt2;
-      t = (t1 < 0.0) ? t2 : t1;
-
-      z_t = z + pz * t;
-      if(TMath::Abs(z_t) > fHalfLength)
-      {
-        t3 = (+fHalfLength - z) / pz;
-        t4 = (-fHalfLength - z) / pz;
-        t = (t3 < 0.0) ? t4 : t3;
-      }
+      t_r = (TMath::Sqrt(pt2 * fRadius2 - tmp * tmp) - px * x - py * y) / pt2;
+
+      t_z = (TMath::Sign(fHalfLength, pz) - z) / pz;
+
+      t = TMath::Min(t_r, t_z);
 
       x_t = x + px * t;
@@ -245,4 +232,5 @@
 
       fOutputArray->Add(candidate);
+
       if(TMath::Abs(q) > 1.0E-9)
       {
@@ -267,12 +255,12 @@
     {
 
-      // 1.  initial transverse momentum p_{T0}: Part->pt
-      //     initial transverse momentum direction phi_0 = -atan(p_X0/p_Y0)
-      //     relativistic gamma: gamma = E/mc^2; gammam = gamma * m
-      //     gyration frequency omega = q/(gamma m) fBz
-      //     helix radius r = p_{T0} / (omega gamma m)
+      // 1. initial transverse momentum p_{T0}: Part->pt
+      //    initial transverse momentum direction phi_0 = -atan(p_{X0} / p_{Y0})
+      //    relativistic gamma: gamma = E / mc^2; gammam = gamma * m
+      //    gyration frequency omega = q * Bz / (gammam)
+      //    helix radius r = p_{T0} / (omega * gammam)
 
       gammam = e * 1.0E9 / (c_light * c_light); // gammam in [eV/c^2]
-      omega = q * fBz / (gammam); // omega is here in [89875518/s]
+      omega = q * fBz / gammam; // omega is here in [89875518/s]
       r = pt / (q * fBz) * 1.0E9 / c_light; // in [m]
 
@@ -283,33 +271,32 @@
       y_c = y - r * TMath::Cos(phi_0);
       r_c = TMath::Hypot(x_c, y_c);
-      phi_c = TMath::ATan2(y_c, x_c);
-      phi = phi_c;
-      if(x_c < 0.0) phi += TMath::Pi();
-
-      rcu = TMath::Abs(r);
-      rc2 = r_c * r_c;
-
-      // calculate coordinates of closest approach to track circle in transverse plane xd, yd, zd
-      xd = x_c * x_c * x_c - x_c * rcu * r_c + x_c * y_c * y_c;
-      xd = (rc2 > 0.0) ? xd / rc2 : -999;
-      yd = y_c * (-rcu * r_c + rc2);
-      yd = (rc2 > 0.0) ? yd / rc2 : -999;
-      zd = z + (TMath::Sqrt(xd * xd + yd * yd) - TMath::Sqrt(x * x + y * y)) * pz / pt;
-
-      // use perigee momentum rather than original particle
-      // momentum, since the orignal particle momentum isn't known
-
-      px = TMath::Sign(1.0, r) * pt * (-y_c / r_c);
-      py = TMath::Sign(1.0, r) * pt * (x_c / r_c);
-      etap = particleMomentum.Eta();
-      phip = TMath::ATan2(py, px);
-
-      particleMomentum.SetPtEtaPhiE(pt, etap, phip, particleMomentum.E());
+
+      // time of closest approach
+      td = (phi_0 + TMath::ATan2(x_c, y_c)) / omega;
+
+      // remove all the modulo pi that might have come from the atan
+      pio = TMath::Abs(TMath::Pi() / omega);
+      while(TMath::Abs(td) > 0.5 * pio)
+      {
+        td -= TMath::Sign(1.0, td) * pio;
+      }
+
+      vz = pz * c_light / e;
+
+      // calculate coordinates of closest approach to z axis
+      phid = phi_0 - omega * td;
+      xd = x_c - r * TMath::Sin(phid);
+      yd = y_c + r * TMath::Cos(phid);
+      zd = z + vz * td;
+
+      // momentum at closest approach
+      px = pt * TMath::Cos(phid);
+      py = pt * TMath::Sin(phid);
+
+      particleMomentum.SetPtEtaPhiE(pt, particleMomentum.Eta(), phid, particleMomentum.E());
 
       // calculate additional track parameters (correct for beamspot position)
-
-      d0 = ((x - bsx) * py - (y - bsy) * px) / pt;
-      dz = z - ((x - bsx) * px + (y - bsy) * py) / pt * (pz / pt);
-      p = particleMomentum.P();
+      d0 = ((xd - bsx) * py - (yd - bsy) * px) / pt;
+      dz = zd - bsz;
       ctgTheta = 1.0 / TMath::Tan(particleMomentum.Theta());
 
@@ -317,10 +304,5 @@
       //    t_r : time to exit from the sides
       //    t_z : time to exit from the front or the back
-      t_r = 0.0; // in [ns]
-      int sign_pz = (pz > 0.0) ? 1 : -1;
-      if(pz == 0.0)
-        t_z = 1.0E99;
-      else
-        t_z = gammam / (pz * 1.0E9 / c_light) * (-z + fHalfLength * sign_pz);
+      t_z = (vz == 0.0) ? 1.0E99 : (TMath::Sign(fHalfLength, pz) - z) / vz;
 
       if(r_c + TMath::Abs(r) < fRadius)
@@ -331,42 +313,22 @@
       else
       {
-        asinrho = TMath::ASin((fRadius * fRadius - r_c * r_c - r * r) / (2 * TMath::Abs(r) * r_c));
-        delta = phi_0 - phi;
-        if(delta < -TMath::Pi()) delta += 2 * TMath::Pi();
-        if(delta > TMath::Pi()) delta -= 2 * TMath::Pi();
-        t1 = (delta + asinrho) / omega;
-        t2 = (delta + TMath::Pi() - asinrho) / omega;
-        t3 = (delta + TMath::Pi() + asinrho) / omega;
-        t4 = (delta - asinrho) / omega;
-        t5 = (delta - TMath::Pi() - asinrho) / omega;
-        t6 = (delta - TMath::Pi() + asinrho) / omega;
-
-        if(t1 < 0.0) t1 = 1.0E99;
-        if(t2 < 0.0) t2 = 1.0E99;
-        if(t3 < 0.0) t3 = 1.0E99;
-        if(t4 < 0.0) t4 = 1.0E99;
-        if(t5 < 0.0) t5 = 1.0E99;
-        if(t6 < 0.0) t6 = 1.0E99;
-
-        t_ra = TMath::Min(t1, TMath::Min(t2, t3));
-        t_rb = TMath::Min(t4, TMath::Min(t5, t6));
-        t_r = TMath::Min(t_ra, t_rb);
+        alpha = TMath::ACos((r * r + r_c * r_c - fRadius * fRadius) / (2 * TMath::Abs(r) * r_c));
+        t_r = td + TMath::Abs(alpha / omega);
+
         t = TMath::Min(t_r, t_z);
       }
 
       // 4. position in terms of x(t), y(t), z(t)
-      x_t = x_c + r * TMath::Sin(omega * t - phi_0);
-      y_t = y_c + r * TMath::Cos(omega * t - phi_0);
-      z_t = z + pz * 1.0E9 / c_light / gammam * t;
+      phi_t = phi_0 - omega * t;
+      x_t = x_c - r * TMath::Sin(phi_t);
+      y_t = y_c + r * TMath::Cos(phi_t);
+      z_t = z + vz * t;
       r_t = TMath::Hypot(x_t, y_t);
 
-      // compute path length for an helix
-
-      alpha = pz * 1.0E9 / c_light / gammam;
-      l = t * TMath::Sqrt(alpha * alpha + r * r * omega * omega);
+      // lenght of the path from production to tracker
+      l = t * TMath::Hypot(vz, r * omega);
 
       if(r_t > 0.0)
       {
-
         // store these variables before cloning
         if(particle == candidate)
@@ -374,8 +336,8 @@
           particle->D0 = d0 * 1.0E3;
           particle->DZ = dz * 1.0E3;
-          particle->P = p;
+          particle->P = particleMomentum.P();
           particle->PT = pt;
           particle->CtgTheta = ctgTheta;
-          particle->Phi = phip;
+          particle->Phi = particleMomentum.Phi();
         }
 
Index: modules/SimpleCalorimeter.cc
===================================================================
--- modules/SimpleCalorimeter.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/SimpleCalorimeter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -208,8 +208,13 @@
   fItParticleInputArray->Reset();
   number = -1;
+  fTowerRmax=0.;
   while((particle = static_cast<Candidate *>(fItParticleInputArray->Next())))
   {
     const TLorentzVector &particlePosition = particle->Position;
     ++number;
+
+    // compute maximum radius (needed in FinalizeTower to assess whether barrel or endcap tower)
+    if (particlePosition.Perp() > fTowerRmax)
+      fTowerRmax=particlePosition.Perp();
 
     pdgCode = TMath::Abs(particle->PID);
@@ -394,8 +399,10 @@
     fTowerEnergy += energy;
 
-    fTowerTime += energy * position.T();
-    fTowerTimeWeight += energy;
+    fTowerTime += energy * energy * position.T(); //sigma_t ~ 1/E
+    fTowerTimeWeight += energy * energy;
 
     fTower->AddCandidate(particle);
+    fTower->Position = position;
+
   }
 
@@ -409,5 +416,5 @@
 {
   Candidate *tower, *track, *mother;
-  Double_t energy, neutralEnergy, pt, eta, phi;
+  Double_t energy, neutralEnergy, pt, eta, phi, r;
   Double_t sigma, neutralSigma;
   Double_t time;
@@ -443,9 +450,20 @@
   pt = energy / TMath::CosH(eta);
 
-  fTower->Position.SetPtEtaPhiE(1.0, eta, phi, time);
+  // endcap
+  if (TMath::Abs(fTower->Position.Pt() - fTowerRmax) > 1.e-06 && TMath::Abs(eta) > 0.){
+    r = fTower->Position.Z()/TMath::SinH(eta);
+  }
+  // barrel
+  else {
+    r = fTower->Position.Pt();
+  }
+
+  fTower->Position.SetPtEtaPhiE(r, eta, phi, time);
   fTower->Momentum.SetPtEtaPhiE(pt, eta, phi, energy);
+  fTower->L = fTower->Position.Vect().Mag();
 
   fTower->Eem = (!fIsEcal) ? 0 : energy;
   fTower->Ehad = (fIsEcal) ? 0 : energy;
+  fTower->Etrk = fTrackEnergy;
 
   fTower->Edges[0] = fTowerEdges[0];
@@ -507,7 +525,5 @@
       track = static_cast<Candidate *>(track->Clone());
       track->AddCandidate(mother);
-
-      track->Momentum *= rescaleFactor;
-
+      track->Momentum.SetPtEtaPhiM(track->Momentum.Pt()*rescaleFactor, track->Momentum.Eta(), track->Momentum.Phi(), track->Momentum.M());
       fEFlowTrackOutputArray->Add(track);
     }
Index: modules/SimpleCalorimeter.h
===================================================================
--- modules/SimpleCalorimeter.h	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/SimpleCalorimeter.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -62,4 +62,6 @@
   Double_t fTrackTime;
 
+  Double_t fTowerRmax;
+
   Double_t fTowerTimeWeight;
   Double_t fTrackTimeWeight;
Index: modules/TauTagging.cc
===================================================================
--- modules/TauTagging.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TauTagging.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -83,7 +83,7 @@
     daughter1 = static_cast<Candidate *>(fParticleInputArray->At(i));
     pdgCode = TMath::Abs(daughter1->PID);
-    if(pdgCode == 11 || pdgCode == 13 || pdgCode == 15)
-      return -1;
-    else if(pdgCode == 24)
+    //if(pdgCode == 11 || pdgCode == 13 || pdgCode == 15)
+    //  return -1;
+    if(pdgCode == 24)
     {
       if(daughter1->D1 < 0) return -1;
@@ -96,5 +96,4 @@
     }
   }
-
   return 0;
 }
@@ -190,5 +189,5 @@
 void TauTagging::Process()
 {
-  Candidate *jet, *tau, *daughter;
+  Candidate *jet, *tau, *daughter, *part;
   TLorentzVector tauMomentum;
   Double_t pt, eta, phi, e, eff;
@@ -204,6 +203,8 @@
   // loop over all input jets
   fItJetInputArray->Reset();
+
   while((jet = static_cast<Candidate *>(fItJetInputArray->Next())))
   {
+
     const TLorentzVector &jetMomentum = jet->Momentum;
     pdgCode = 0;
@@ -243,4 +244,31 @@
       }
     }
+    
+    // fake electrons and muons
+    
+    if (pdgCode == 0)
+    {
+     
+      Double_t drMin = fDeltaR;   
+      fItPartonInputArray->Reset();
+      while((part = static_cast<Candidate *>(fItPartonInputArray->Next())))
+      {
+        if(TMath::Abs(part->PID) == 11 || TMath::Abs(part->PID) == 13) 
+        {
+            tauMomentum = part->Momentum;
+            if (tauMomentum.Pt() < fClassifier->fPTMin) continue;
+            if (TMath::Abs(tauMomentum.Eta()) > fClassifier->fEtaMax) continue;
+
+            Double_t dr = jetMomentum.DeltaR(tauMomentum);
+            if( dr < drMin)
+            {
+               drMin = dr;
+               pdgCode = TMath::Abs(part->PID);
+               charge = part->Charge;
+            }  
+        }
+      }
+    }
+
     // find an efficency formula
     itEfficiencyMap = fEfficiencyMap.find(pdgCode);
Index: modules/TimeOfFlight.cc
===================================================================
--- modules/TimeOfFlight.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TimeOfFlight.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,223 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+ /** \class TimeOfFlight
+  *
+  *  Calculates Time-Of-Flight
+  *
+  *  \author Michele Selvaggi - CERN
+  *
+ */
+
+#include "modules/TimeOfFlight.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include "ExRootAnalysis/ExRootClassifier.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootResult.h"
+
+#include "TDatabasePDG.h"
+#include "TFormula.h"
+#include "TLorentzVector.h"
+#include "TMath.h"
+#include "TObjArray.h"
+#include "TRandom3.h"
+#include "TString.h"
+
+#include <algorithm>
+#include <iostream>
+#include <sstream>
+#include <stdexcept>
+
+using namespace std;
+//------------------------------------------------------------------------------
+
+TimeOfFlight::TimeOfFlight() :
+  fItInputArray(0), fItVertexInputArray(0)
+{
+}
+
+//------------------------------------------------------------------------------
+
+TimeOfFlight::~TimeOfFlight()
+{
+}
+
+//------------------------------------------------------------------------------
+
+void TimeOfFlight::Init()
+{
+
+  // method to compute vertex time
+  fVertexTimeMode = GetInt("VertexTimeMode", 0);
+
+  // import track input array
+  fInputArray = ImportArray(GetString("InputArray", "MuonMomentumSmearing/muons"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // import vertex input array
+  fVertexInputArray = ImportArray(GetString("VertexInputArray", "TruthVertexFinder/vertices"));
+  fItVertexInputArray = fVertexInputArray->MakeIterator();
+
+  // create output array
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
+}
+
+//------------------------------------------------------------------------------
+
+void TimeOfFlight::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+  if(fItVertexInputArray) delete fItVertexInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void TimeOfFlight::Process()
+{
+  Candidate *candidate, *particle, *vertex, *constituent, *mother;
+  Double_t ti, t_truth, tf;
+  Double_t l, tof, beta, p,  mass;
+
+  const Double_t c_light = 2.99792458E8;
+
+  // first compute momenta of vertices based on reconstructed tracks
+  ComputeVertexMomenta();
+
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
+  {
+
+    particle = static_cast<Candidate *>(candidate->GetCandidates()->At(0));
+
+    const TLorentzVector &candidateInitialPosition = particle->Position;
+    const TLorentzVector &candidateInitialPositionSmeared = candidate->InitialPosition;
+    const TLorentzVector &candidateFinalPosition = candidate->Position;
+    const TLorentzVector &candidateMomentum = particle->Momentum;
+
+    // time at vertex from MC truth
+    t_truth = candidateInitialPosition.T() * 1.0E-3 / c_light;
+
+    // various options on how to calculate the vertex time
+    ti=0;
+    switch (fVertexTimeMode)
+	  {
+    	case 0:
+    	{
+        // assume ti from MC truth
+        // most aggressive, we are cheating and assume we can perfectly reconstruct time of primary and secondary vertices
+        ti = t_truth;
+        break;
+    	}
+    	case 1:
+    	{
+        // always assume t=0, most conservative assumption
+        // reasonable assumption for particles originating from PV, if beamSpot has small time spread compared to timing resolution
+        // probably bad assumption for particles from highly displaced vertices (i.e Ks)
+        ti=0;
+        break;
+    	}
+    	case 2:
+    	{
+        // same as 2 but attempt at estimate beta from vertex mass and momentum
+        beta = 1.;
+        fItVertexInputArray->Reset();
+        while((vertex = static_cast<Candidate *>(fItVertexInputArray->Next())))
+        {
+          TIter itGenParts(vertex->GetCandidates());
+          itGenParts.Reset();
+
+          while((constituent = static_cast<Candidate *>(itGenParts.Next())))
+          {
+            if (particle == constituent)
+            {
+              beta = vertex->Momentum.Beta();
+              break;
+            }
+          }
+        } // end vertex  loop
+
+        // track displacement to be possibily replaced by vertex fitted position
+        ti = candidateInitialPositionSmeared.Vect().Mag() * 1.0E-3 /(beta*c_light);
+      }
+      break;
+  	}
+
+    p = candidateMomentum.P();
+
+    // this quantity has already been smeared by another module
+    tf = candidateFinalPosition.T() * 1.0E-3 / c_light;
+
+    // calculate time-of-flight
+    tof = tf - ti;
+    // path length of the full helix
+    l = candidate->L * 1.0E-3;
+
+    // particle velocity
+    beta = l/(c_light*tof);
+
+    // calculate particle mass (i.e particle ID)
+    mass = 0.;
+    if (beta<1) mass = p* TMath::Sqrt(1/(beta*beta) - 1);
+
+    mother    = candidate;
+    candidate = static_cast<Candidate*>(candidate->Clone());
+
+    // update time at vertex based on option
+    candidate->InitialPosition.SetT(ti * 1.0E3 * c_light);
+
+    // update particle mass based on TOF-based PID (commented for now, assume this calculation is done offline)
+    //candidate->Momentum.SetVectM(candidateMomentum.Vect(), mass);
+
+    candidate->AddCandidate(mother);
+    fOutputArray->Add(candidate);
+  }
+}
+
+//------------------------------------------------------------------------------
+
+void TimeOfFlight::ComputeVertexMomenta()
+{
+  Candidate *track, *constituent, *particle, *vertex;
+
+  fItVertexInputArray->Reset();
+  while((vertex = static_cast<Candidate *>(fItVertexInputArray->Next())))
+  {
+
+    TIter itGenParts(vertex->GetCandidates());
+    itGenParts.Reset();
+
+    while((constituent = static_cast<Candidate *>(itGenParts.Next())))
+    {
+      fItInputArray->Reset();
+      while((track = static_cast<Candidate *>(fItInputArray->Next())))
+      {
+        // get gen part that generated track
+        particle = static_cast<Candidate *>(track->GetCandidates()->At(0));
+        if (particle == constituent)
+        {
+          vertex->Momentum += track->Momentum;
+        }
+
+      } // end track loop
+    } // end vertex consitutent loop
+  } // end vertex  loop
+}
Index: modules/TimeOfFlight.h
===================================================================
--- modules/TimeOfFlight.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TimeOfFlight.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,61 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef TimeOfFlight_h
+#define TimeOfFlight_h
+
+/** \class TimeOfFlight
+ *
+ *  Calculates Time-Of-Flight
+ *
+ *  \author Michele Selvaggi - CERN
+ *
+*/
+
+#include "classes/DelphesModule.h"
+
+class TIterator;
+class TObjArray;
+
+class TimeOfFlight: public DelphesModule
+{
+public:
+  TimeOfFlight();
+  ~TimeOfFlight();
+
+  void Init();
+  void Process();
+  void Finish();
+  void ComputeVertexMomenta();
+
+private:
+
+  Int_t fVertexTimeMode;
+
+  TIterator *fItInputArray; //!
+  TIterator *fItVertexInputArray; //!
+
+  const TObjArray *fInputArray; //!
+  const TObjArray *fVertexInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(TimeOfFlight, 1)
+};
+
+#endif
Index: modules/TimeSmearing.cc
===================================================================
--- modules/TimeSmearing.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TimeSmearing.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -19,7 +19,7 @@
 /** \class TimeSmearing
  *
- *  Performs transverse momentum resolution smearing.
+ *  Performs time smearing.
  *
- *  \author P. Demin - UCL, Louvain-la-Neuve
+ *  \author M. Selvaggi - CERN
  *
  */
@@ -49,10 +49,10 @@
 
 using namespace std;
-
 //------------------------------------------------------------------------------
 
 TimeSmearing::TimeSmearing() :
-  fItInputArray(0)
+  fItInputArray(0), fResolutionFormula(0)
 {
+	fResolutionFormula = new DelphesFormula;
 }
 
@@ -61,4 +61,5 @@
 TimeSmearing::~TimeSmearing()
 {
+	if(fResolutionFormula) delete fResolutionFormula;
 }
 
@@ -69,13 +70,14 @@
   // read resolution formula
 
-  fTimeResolution = GetDouble("TimeResolution", 1.0E-10);
-  // import input array
+  // read time resolution formula in seconds
+  fResolutionFormula->Compile(GetString("TimeResolution", "30e-12"));
 
+  // import track input array
   fInputArray = ImportArray(GetString("InputArray", "MuonMomentumSmearing/muons"));
   fItInputArray = fInputArray->MakeIterator();
 
+
   // create output array
-
-  fOutputArray = ExportArray(GetString("OutputArray", "muons"));
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
 }
 
@@ -92,5 +94,8 @@
 {
   Candidate *candidate, *mother;
-  Double_t ti, tf_smeared, tf;
+  Double_t tf_smeared, tf;
+  Double_t eta, energy;
+  Double_t timeResolution;
+
   const Double_t c_light = 2.99792458E8;
 
@@ -98,27 +103,25 @@
   while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
   {
-    const TLorentzVector &candidateInitialPosition = candidate->InitialPosition;
+
     const TLorentzVector &candidateFinalPosition = candidate->Position;
+    const TLorentzVector &candidateMomentum = candidate->Momentum;
 
-    ti = candidateInitialPosition.T() * 1.0E-3 / c_light;
     tf = candidateFinalPosition.T() * 1.0E-3 / c_light;
 
+    eta = candidateMomentum.Eta();
+    energy = candidateMomentum.E();
+
     // apply smearing formula
-    tf_smeared = gRandom->Gaus(tf, fTimeResolution);
-    ti = ti + tf_smeared - tf;
-    tf = tf_smeared;
+    timeResolution = fResolutionFormula->Eval(0.0, eta, 0.0, energy);
+    tf_smeared = gRandom->Gaus(tf, timeResolution);
 
     mother = candidate;
     candidate = static_cast<Candidate *>(candidate->Clone());
-    candidate->InitialPosition.SetT(ti * 1.0E3 * c_light);
-    candidate->Position.SetT(tf * 1.0E3 * c_light);
 
-    candidate->ErrorT = fTimeResolution * 1.0E3 * c_light;
+    candidate->Position.SetT(tf_smeared * 1.0E3 * c_light);
+    candidate->ErrorT = timeResolution * 1.0E3 * c_light;
 
     candidate->AddCandidate(mother);
-
     fOutputArray->Add(candidate);
   }
 }
-
-//------------------------------------------------------------------------------
